package org.gcube.data.transfer.library;

import java.net.MalformedURLException;

import org.gcube.common.scope.api.ScopeProvider;
import org.gcube.data.transfer.library.faults.FailedTransferException;
import org.gcube.data.transfer.library.faults.InitializationException;
import org.gcube.data.transfer.library.faults.InvalidSourceException;
import org.gcube.data.transfer.library.faults.ServiceNotFoundException;
import org.gcube.data.transfer.library.faults.SourceNotSetException;
import org.gcube.data.transfer.library.faults.UnreachableNodeException;
import org.junit.BeforeClass;
import org.junit.Test;

public class TransfererTest {

	static String hostname="http://pc-fabio.isti.cnr.it:8080";
	static String scope="/gcube/devNext";
	
	static DataTransferClient client;
	
	@BeforeClass
	public static void init() throws UnreachableNodeException, ServiceNotFoundException{
		ScopeProvider.instance.set(scope);
		client=DataTransferClient.getInstanceByEndpoint(hostname);
	}
	
	@Test
	public void localFile() throws InvalidSourceException, SourceNotSetException, FailedTransferException, InitializationException{
		String localFile="/home/fabio/Downloads/Puntata 3.mp3";
		System.out.println(client.localFile(localFile));
	}
	
	
	@Test
	public void httpUrl() throws MalformedURLException, InvalidSourceException, SourceNotSetException, FailedTransferException, InitializationException{
		String link="https://www.dropbox.com/s/giqsbgmlkk9zklc/COMA%20-%20Last%20Aim.mp3?dl=0";
		System.out.println(client.httpSource(link));
	}
	
	
	@Test
	public void storage() throws InvalidSourceException, SourceNotSetException, FailedTransferException, InitializationException{
		String toUpload="/home/fabio/Downloads/Incantesimi3_5.doc";
		System.out.println(client.storageId(toUpload));
	}
}
